/* packet-dcerpc-BOSSVR.c
 *
 * Routines for dcerpc BOSSVR dissection
 * Copyright 2002, Jaime Fournier <jafour1@yahoo.com>
 * This information is based off the released idl files from opengroup.
 * ftp://opengroup.org/
 *      
 *     
 *
 * $Id: packet-dcerpc-BOSSVR.c,v 1.2 2002/01/21 07:36:33 guy Exp $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@ethereal.com>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#include <string.h>

#include <glib.h>
#include <epan/packet.h>
#include "packet-dcerpc.h"


static int proto_BOSSVR = -1;

static gint ett_BOSSVR = -1;


static e_uuid_t uuid_BOSSVR = { 0x4d37f2dd, 0xed43, 0x0000, { 0x02, 0xc0, 0x37, 0xcf, 0x1e, 0x00, 0x00, 0x01 } };
static guint16  ver_BOSSVR = 0;


static dcerpc_sub_dissector BOSSVR_dissectors[] = {
    { 0, "BOSSVR_GetServerStatus", NULL, NULL},
    { 1, "BOSSVR_CreateBnode", NULL, NULL},
    { 2, "BOSSVR_DeleteBnode", NULL, NULL},
    { 3, "BOSSVR_SetStatus", NULL, NULL},
    { 4, "BOSSVR_GetStatus", NULL, NULL},
    { 5, "BOSSVR_EnumerateInstance", NULL, NULL},
    { 6, "BOSSVR_GetInstanceInfo", NULL, NULL},
    { 7, "BOSSVR_GetInstanceParm", NULL, NULL},
    { 8, "BOSSVR_AddSUser", NULL, NULL},
    { 9, "BOSSVR_DeleteSUser", NULL, NULL},
    { 10, "BOSSVR_ListSUsers", NULL, NULL},
    { 11, "BOSSVR_ListKeys", NULL, NULL},
    { 12, "BOSSVR_AddKey", NULL, NULL},
    { 13, "BOSSVR_DeleteKey", NULL, NULL},
    { 14, "BOSSVR_GenerateKey", NULL, NULL},
    { 15, "BOSSVR_GarbageCollectKeys", NULL, NULL},
    { 16, "BOSSVR_GetCellName", NULL, NULL},
    { 17, "BOSSVR_SetTStatus", NULL, NULL},
    { 18, "BOSSVR_ShutdownAll", NULL, NULL},
    { 19, "BOSSVR_RestartAll", NULL, NULL},
    { 20, "BOSSVR_StartupAll", NULL, NULL},
    { 21, "BOSSVR_SetNoAuthFlag", NULL, NULL},
    { 22, "BOSSVR_ReBossvr", NULL, NULL},
    { 23, "BOSSVR_Restart", NULL, NULL},
    { 24, "BOSSVR_Install", NULL, NULL},
    { 25, "BOSSVR_UnInstall", NULL, NULL},
    { 26, "BOSSVR_GetDates", NULL, NULL},
    { 27, "BOSSVR_Prune", NULL, NULL},
    { 28, "BOSSVR_SetRestartTime", NULL, NULL},
    { 29, "BOSSVR_GetRestartTime", NULL, NULL},
    { 30, "BOSSVR_GetLog", NULL, NULL},
    { 31, "BOSSVR_WaitAll", NULL, NULL},
    { 32, "BOSSVR_SetDebug", NULL, NULL},
    { 33, "BOSSVR_GetServerInterfaces", NULL, NULL},
    { 0, NULL, NULL, NULL },
};


void
proto_register_BOSSVR (void)
{
#if 0
	static hf_register_info hf[] = {
	};
#endif

	static gint *ett[] = {
		&ett_BOSSVR,
	};
	proto_BOSSVR = proto_register_protocol ("DCE/RPC BOS Server", "BOSSVR", "BOSSVR");
#if 0
	proto_register_field_array (proto_BOSSVR, hf, array_length (hf));
#endif
	proto_register_subtree_array (ett, array_length (ett));
}

void
proto_reg_handoff_BOSSVR (void)
{
	/* Register the protocol as dcerpc */
	dcerpc_init_uuid (proto_BOSSVR, ett_BOSSVR, &uuid_BOSSVR, ver_BOSSVR, BOSSVR_dissectors, -1);
}
