/* packet-dcerpc-FTSERVER.c
 *
 * Routines for dcerpc FTSERVER dissection
 * Copyright 2002, Jaime Fournier <jafour1@yahoo.com>
 * This information is based off the released idl files from opengroup.
 * ftp://opengroup.org/
 *
 * $Id: packet-dcerpc-FTSERVER.c,v 1.2 2002/01/21 07:36:33 guy Exp $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@ethereal.com>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#include <string.h>

#include <glib.h>
#include <epan/packet.h>
#include "packet-dcerpc.h"


static int proto_FTSERVER = -1;

static gint ett_FTSERVER = -1;


static e_uuid_t uuid_FTSERVER = { 0x4d37f2dd, 0xed43, 0x0004, { 0x02, 0xc0, 0x37, 0xcf, 0x1e, 0x00, 0x00, 0x00 } };
static guint16  ver_FTSERVER = 4;


static dcerpc_sub_dissector FTSERVER_dissectors[] = {
	{ 0, "FTSERVER_CreateTrans", NULL, NULL},
	{ 1, "FTSERVER_AbortTrans", NULL, NULL},
	{ 2, "FTSERVER_DeleteTrans", NULL, NULL},
	{ 3, "FTSERVER_CreateVolume", NULL, NULL},
	{ 4, "FTSERVER_DeleteVolume", NULL, NULL},
	{ 5, "FTSERVER_Dump", NULL, NULL},
	{ 6, "FTSERVER_Restore", NULL, NULL},
	{ 7, "FTSERVER_Forward", NULL, NULL},
	{ 8, "FTSERVER_Clone", NULL, NULL},
	{ 9, "FTSERVER_ReClone", NULL, NULL},
	{ 10, "FTSERVER_GetFlags", NULL, NULL},
	{ 11, "FTSERVER_SetFlags", NULL, NULL},
	{ 12, "FTSERVER_GetStatus", NULL, NULL},
	{ 13, "FTSERVER_SetStatus", NULL, NULL},
	{ 14, "FTSERVER_ListVolumes", NULL, NULL},
	{ 15, "FTSERVER_ListAggregates", NULL, NULL},
	{ 16, "FTSERVER_AggregateInfo", NULL, NULL},
	{ 17, "FTSERVER_Monitor", NULL, NULL},
	{ 18, "FTSERVER_GetOneVolStatus", NULL, NULL},
	{ 19, "FTSERVER_GetServerInterfaces", NULL, NULL},
	{ 20, "FTSERVER_SwapIDs", NULL, NULL},
    { 0, NULL, NULL, NULL },
};


void
proto_register_FTSERVER (void)
{
#if 0
	static hf_register_info hf[] = {
	};
#endif

	static gint *ett[] = {
		&ett_FTSERVER,
	};
	proto_FTSERVER = proto_register_protocol ("FTServer Operations", "FTSERVER", "FTSERVER");
#if 0
	proto_register_field_array (proto_FTSERVER, hf, array_length (hf));
#endif
	proto_register_subtree_array (ett, array_length (ett));
}

void
proto_reg_handoff_FTSERVER (void)
{
	/* Register the protocol as dcerpc */
	dcerpc_init_uuid (proto_FTSERVER, ett_FTSERVER, &uuid_FTSERVER, ver_FTSERVER, FTSERVER_dissectors, -1);
}
