/* packet-dcerpc-UBIKDISK.c
 *
 * Routines for dcerpc UBIK Disk routines
 * Copyright 2002, Jaime Fournier <jafour1@yahoo.com>
 * This information is based off the released idl files from opengroup.
 * ftp://opengroup.org/
 *
 * $Id: packet-dcerpc-UBIKDISK.c,v 1.2 2002/01/21 07:36:33 guy Exp $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@ethereal.com>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#include <string.h>

#include <glib.h>
#include <epan/packet.h>
#include "packet-dcerpc.h"


static int proto_UBIKDISK = -1;

static gint ett_UBIKDISK = -1;


static e_uuid_t uuid_UBIKDISK = { 0x4d37f2dd, 0xed43, 0x0002, { 0x02, 0xc0, 0x37, 0xcf, 0x1e, 0x00, 0x00, 0x00 } };
static guint16  ver_UBIKDISK = 4;


static dcerpc_sub_dissector UBIKDISK_dissectors[] = {
	{ 0, "UBIKDISK_Begin", NULL, NULL},
	{ 1, "UBIKDISK_Commit", NULL, NULL},
	{ 2, "UBIKDISK_Lock", NULL, NULL},
	{ 3, "UBIKDISK_Write", NULL, NULL},
	{ 4, "UBIKDISK_GetVersion", NULL, NULL},
	{ 5, "UBIKDISK_GetFile", NULL, NULL},
	{ 6, "UBIKDISK_SendFile", NULL, NULL},
	{ 7, "UBIKDISK_Abort", NULL, NULL},
	{ 8, "UBIKDISK_ReleaseLocks", NULL, NULL},
	{ 9, "UBIKDISK_Truncate", NULL, NULL},
	{ 10, "UBIKDISK_Probe", NULL, NULL},
	{ 11, "UBIKDISK_GetServerInterfaces", NULL, NULL},
	{ 12, "UBIKDISK_BulkUpdate", NULL, NULL},
        { 0, NULL, NULL, NULL },
};


void
proto_register_UBIKDISK (void)
{
#if 0
	static hf_register_info hf[] = {
	};
#endif

	static gint *ett[] = {
		&ett_UBIKDISK,
	};
	proto_UBIKDISK = proto_register_protocol ("DCE/RPC FLDB UBIK TRANSFER", "UBIKDISK", "UBIKDISK");
#if 0
	proto_register_field_array (proto_UBIKDISK, hf, array_length (hf));
#endif
	proto_register_subtree_array (ett, array_length (ett));
}

void
proto_reg_handoff_UBIKDISK (void)
{
	/* Register the protocol as dcerpc */
	dcerpc_init_uuid (proto_UBIKDISK, ett_UBIKDISK, &uuid_UBIKDISK, ver_UBIKDISK, UBIKDISK_dissectors, -1);
}
