/* packet-dcerpc-UBIKVOTE.c
 *
 * Routines for dcerpc Ubik Voting  routines.
 * Copyright 2002, Jaime Fournier <jafour1@yahoo.com>
 * This information is based off the released idl files from opengroup.
 * ftp://opengroup.org/
 *
 * $Id: packet-dcerpc-UBIKVOTE.c,v 1.2 2002/01/21 07:36:33 guy Exp $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@ethereal.com>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#include <string.h>

#include <glib.h>
#include <epan/packet.h>
#include "packet-dcerpc.h"


static int proto_UBIKVOTE = -1;

static gint ett_UBIKVOTE = -1;


static e_uuid_t uuid_UBIKVOTE = { 0x4d37f2dd, 0xed43, 0x0003, { 0x02, 0xc0, 0x37, 0xcf, 0x1e, 0x00, 0x00, 0x00 } };
static guint16  ver_UBIKVOTE = 4;


static dcerpc_sub_dissector UBIKVOTE_dissectors[] = {
	{ 0, "UBIKVOTE_Beacon", NULL, NULL},
	{ 1, "UBIKVOTE_Debug", NULL, NULL},
	{ 2, "UBIKVOTE_SDebug", NULL, NULL},
	{ 3, "UBIKVOTE_GetServerInterfaces", NULL, NULL},
	{ 4, "UBIKVOTE_GetSyncSite", NULL, NULL},
	{ 5, "UBIKVOTE_DebugV2", NULL, NULL},
	{ 6, "UBIKVOTE_SDebugV2", NULL, NULL},
	{ 7, "UBIKVOTE_GetSyncSiteIdentity", NULL, NULL},
        { 0, NULL, NULL, NULL },
};


void
proto_register_UBIKVOTE (void)
{
#if 0
	static hf_register_info hf[] = {
	};
#endif

	static gint *ett[] = {
		&ett_UBIKVOTE,
	};
	proto_UBIKVOTE = proto_register_protocol ("DCE/RPC FLDB", "UBIKVOTE", "UBIKVOTE");
#if 0
	proto_register_field_array (proto_UBIKVOTE, hf, array_length (hf));
#endif
	proto_register_subtree_array (ett, array_length (ett));
}

void
proto_reg_handoff_UBIKVOTE (void)
{
	/* Register the protocol as dcerpc */
	dcerpc_init_uuid (proto_UBIKVOTE, ett_UBIKVOTE, &uuid_UBIKVOTE, ver_UBIKVOTE, UBIKVOTE_dissectors, -1);
}
