/* packet-dcerpc-VL_.c
 *
 * Routines for dcerpc FLDB Calls
 * Copyright 2002, Jaime Fournier <jafour1@yahoo.com>
 * This information is based off the released idl files from opengroup.
 * ftp://opengroup.org/
 *
 * $Id: packet-dcerpc-VL_.c,v 1.2 2002/01/21 07:36:33 guy Exp $
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@ethereal.com>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif


#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#include <string.h>

#include <glib.h>
#include <epan/packet.h>
#include "packet-dcerpc.h"


static int proto_VL_ = -1;

static gint ett_VL_ = -1;


static e_uuid_t uuid_VL_ = { 0x4d37f2dd, 0xed43, 0x0000, { 0x02, 0xc0, 0x37, 0xcf, 0x2e, 0x00, 0x00, 0x01 } };
static guint16  ver_VL_ = 4;

static int hf_vl_getentrybyname_rqst_var1 = -1;
static int hf_vl_getentrybyname_rqst_key_size = -1;
static int hf_vl_getentrybyname_rqst_key_t = -1;
static int hf_vl_releaselock_rqst_fsid_high = -1;
static int hf_vl_releaselock_rqst_fsid_low = -1;
static int hf_vl_releaselock_rqst_voltype = -1;
static int hf_vl_releaselock_rqst_voloper = -1;
static int hf_vl_setlock_rqst_fsid_high = -1;
static int hf_vl_setlock_rqst_fsid_low = -1;
static int hf_vl_setlock_rqst_voltype = -1;
static int hf_vl_setlock_rqst_voloper = -1;
static int hf_vl_listentry_rqst_previous_index = -1;
static int hf_vl_listentry_rqst_var1 = -1;
static int hf_vl_listentry_resp_count = -1;
static int hf_vl_listentry_resp_next_index = -1;
static int hf_vl_listentry_resp_key_t = -1;
static int hf_vl_listentry_resp_key_size = -1;
static int hf_vl_listentry_resp_key_t2 = -1;
static int hf_vl_listentry_resp_key_size2 = -1;
static int hf_vl_listentry_resp_voltype = -1;
static int hf_vl_createentry_rqst_key_t = -1;
static int hf_vl_createentry_rqst_key_size = -1;
static int hf_vl_deleteentry_rqst_fsid_high = -1;
static int hf_vl_deleteentry_rqst_fsid_low = -1;
static int hf_vl_deleteentry_rqst_voltype = -1;
static int hf_vl_deleteentry_rqst_voloper = -1;
static int hf_vl_getentrybyid_rqst_fsid_high = -1;
static int hf_vl_getentrybyid_rqst_fsid_low = -1;
static int hf_vl_getentrybyid_rqst_voltype = -1;
static int hf_vl_getentrybyid_rqst_voloper = -1;
static int hf_vl_replaceentry_rqst_fsid_high = -1;
static int hf_vl_replaceentry_rqst_fsid_low = -1;
static int hf_vl_replaceentry_rqst_voltype = -1;
static int hf_vl_replaceentry_rqst_key_size = -1;
static int hf_vl_replaceentry_rqst_key_t = -1;
static int hf_vl_getentrybyname_resp_volumetype = -1;
static int hf_vl_getentrybyname_resp_numservers = -1;
static int hf_vl_getentrybyname_resp_sitecookies = -1;
static int hf_vl_getentrybyname_resp_sitepartition = -1;
static int hf_vl_getentrybyname_resp_siteflags = -1;
static int hf_vl_getentrybyname_resp_sitemaxreplat = -1;
static int hf_vl_getentrybyname_resp_volid_high = -1;
static int hf_vl_getentrybyname_resp_volid_low = -1;
static int hf_vl_getentrybyname_resp_voltype = -1;
static int hf_vl_getentrybyname_resp_cloneid_high = -1;
static int hf_vl_getentrybyname_resp_cloneid_low = -1;
static int hf_vl_getentrybyname_resp_flags = -1;
static int hf_vl_getentrybyname_resp_maxtotallat = -1;
static int hf_vl_getentrybyname_resp_hardmaxtotlat = -1;
static int hf_vl_getentrybyname_resp_minpouncedally = -1;
static int hf_vl_getentrybyname_resp_defaultmaxreplat = -1;
static int hf_vl_getentrybyname_resp_reclaimdally = -1;
static int hf_vl_getentrybyname_resp_whenlocked = -1;
static int hf_vl_getentrybyname_resp_spare1 = -1;
static int hf_vl_getentrybyname_resp_spare2 = -1;
static int hf_vl_getentrybyname_resp_spare3 = -1;
static int hf_vl_getentrybyname_resp_spare4 = -1;
static int hf_vl_getentrybyname_resp_key_t = -1;
static int hf_vl_getentrybyname_resp_key_size = -1;
static int hf_vl_getentrybyname_resp_test = -1;
static int hf_vl_getsiteinfo_rqst_type = -1;
static int hf_vl_getsiteinfo_rqst_data0 = -1;
static int hf_vl_getsiteinfo_rqst_data1 = -1;
static int hf_vl_getsiteinfo_rqst_data2 = -1;
static int hf_vl_getsiteinfo_rqst_data3 = -1;
static int hf_vl_getsiteinfo_rqst_data4 = -1;
static int hf_vl_getsiteinfo_rqst_data5 = -1;
static int hf_vl_getsiteinfo_rqst_data6 = -1;
static int hf_vl_getsiteinfo_rqst_data7 = -1;
static int hf_vl_getsiteinfo_rqst_data8 = -1;
static int hf_vl_getsiteinfo_rqst_data9 = -1;
static int hf_vl_getsiteinfo_rqst_data10 = -1;
static int hf_vl_getsiteinfo_rqst_data11 = -1;
static int hf_vl_getsiteinfo_rqst_data12 = -1;
static int hf_vl_getsiteinfo_rqst_data13 = -1;
static int hf_vl_getsiteinfo_resp_type = -1;
static int hf_vl_getsiteinfo_resp_error = -1;
static int hf_vl_getsiteinfo_resp_data0 = -1;
static int hf_vl_getsiteinfo_resp_data1 = -1;
static int hf_vl_getsiteinfo_resp_data2 = -1;
static int hf_vl_getsiteinfo_resp_data3 = -1;
static int hf_vl_getsiteinfo_resp_data4 = -1;
static int hf_vl_getsiteinfo_resp_data5 = -1;
static int hf_vl_getsiteinfo_resp_data6 = -1;
static int hf_vl_getsiteinfo_resp_data7 = -1;
static int hf_vl_getsiteinfo_resp_data8 = -1;
static int hf_vl_getsiteinfo_resp_data9 = -1;
static int hf_vl_getsiteinfo_resp_data10 = -1;
static int hf_vl_getsiteinfo_resp_data11 = -1;
static int hf_vl_getsiteinfo_resp_data12 = -1;
static int hf_vl_getsiteinfo_resp_data13 = -1;
static int hf_vl_getsiteinfo_resp_key_t = -1;
static int hf_vl_getsiteinfo_resp_key_size = -1;
static int hf_vl_getsiteinfo_resp_owner = -1;
static int hf_vl_getsiteinfo_resp_objid = -1;
static int hf_vl_getsiteinfo_resp_creationquota = -1;
static int hf_vl_getsiteinfo_resp_creationuses = -1;
static int hf_vl_getsiteinfo_resp_deletedflag = -1;
static int hf_vl_getsiteinfo_resp_spare2 = -1;
static int hf_vl_getsiteinfo_resp_spare3 = -1;
static int hf_vl_getsiteinfo_resp_spare4 = -1;
static int hf_vl_getsiteinfo_resp_spare5 = -1;



static int 
vl_dissect_getentrybyname_rqst (tvbuff_t *tvb, int offset,
		                 packet_info *pinfo, proto_tree *tree,
			         char *drep)
{
	        guint32 var1;
		char *key_t;
		guint32 key_size;

		/*
		 *     [in] handle_t h,                       
		 *     [in] volumeName volName,
		 *     read in 7 octets, a 32 a 16 and an 8
		 */
						 
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_rqst_var1, &var1);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_rqst_key_size, &key_size);

                proto_tree_add_string (tree, hf_vl_getentrybyname_rqst_key_t, tvb, offset, hf_vl_getentrybyname_rqst_key_size, tvb_get_ptr (tvb, offset, key_size));
	        key_t = tvb_get_ptr(tvb,offset,key_size);
                offset += key_size; 

         if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_GetEntryByName Request for Name: %s", key_t);

		return offset;

}
static int 
vl_dissect_getentrybyname_resp (tvbuff_t *tvb, int offset,
		                 packet_info *pinfo, proto_tree *tree,
			         char *drep)
{
	     guint32 key_size = 112;
	     guint8 test;
	     char *key_t = NULL;
guint32 cloneid_high, cloneid_low, flags, maxtotallat, hardmaxtotlat, minpouncedally, defaultmaxreplat, reclaimdally, whenlocked, spare1, spare2, spare3, spare4;
		guint32 voltype, numservers, sitecookies, sitepartition, siteflags, sitemaxreplat, volid_high, volid_low, volumetype;

	/*
                byte    name[MAXFTNAMELEN];              Volume name 
	*/
		/* If the fileset does not exist, we get 20 as the first number here. So we read, and test.  without advancing offset.*/



		dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_test, &test);

		if (test == 32) {

                if (check_col(pinfo->cinfo, COL_INFO)) col_add_str(pinfo->cinfo, COL_INFO, "VL_GetEntryByName Reply ENOEXIST");
		}else{
	        
                proto_tree_add_string (tree, hf_vl_getentrybyname_resp_key_t, tvb, offset, hf_vl_getentrybyname_resp_key_size, tvb_get_ptr (tvb, offset, key_size));
	        key_t = tvb_get_ptr(tvb,offset,key_size);
                offset += key_size; 

        /*
                unsigned32      volumeType;             / Volume type (VOLTIX_TO_VOLTYPE(RWVOL, ROVOL, BACKVOL)) /
                unsigned32      nServers;               / Number of servers that have this volume /
                unsigned32      siteCookies[MAXNSERVERS]; 16       / cookies for server info /
                unsigned32      sitePartition[MAXNSERVERS]; 16    / Server Partition number /
                unsigned32      siteFlags[MAXNSERVERS];      16  / Server flags /
                unsigned32      sitemaxReplicaLatency[MAXNSERVERS]; 16     / Per-site max latency /
	*/
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_volumetype, &volumetype);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_numservers, &numservers);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_sitecookies, &sitecookies);
		offset += 60; /* bypass the other 15 sitecookies */
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_sitepartition, &sitepartition);
		offset += 60; /* bypass the other 15 elements */
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_siteflags, &siteflags);
		offset += 60; /* bypass the other 15 elements */
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_sitemaxreplat, &sitemaxreplat);
		offset += 60; /* bypass the other 15 elements */

	/*
                afsHyper                VolIDs[MAXVOLTYPES];
	*/	
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_volid_high, &volid_high);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_volid_low, &volid_low);

		offset += 56; /* bypass the other 7 elements */

	/*
                unsigned32      VolTypes[MAXVOLTYPES];
        */		

		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_voltype, &voltype);
		offset += 28; /* bypass the other 7 elements */

	/*	
                afsHyper                cloneId;                / Used during cloning /
                unsigned32      flags;          / General flags /
                unsigned32      maxTotalLatency;
                unsigned32      hardMaxTotalLatency;
                unsigned32      minimumPounceDally;
                unsigned32      defaultMaxReplicaLatency;
                unsigned32      reclaimDally;
                unsigned32      WhenLocked;
                unsigned32      spare1;
                unsigned32      spare2;
                unsigned32      spare3;
                unsigned32      spare4;
	*/
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_cloneid_high, &cloneid_high);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_cloneid_low, &cloneid_low);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_flags, &flags);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_maxtotallat, &maxtotallat);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_hardmaxtotlat, &hardmaxtotlat);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_minpouncedally, &minpouncedally);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_defaultmaxreplat, &defaultmaxreplat);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_reclaimdally, &reclaimdally);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_whenlocked, &whenlocked);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_spare1, &spare1);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_spare2, &spare2);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_spare3, &spare3);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyname_resp_spare4, &spare4);

	/*
                byte    LockerName[MAXLOCKNAMELEN]; 64
                byte    charSpares[50];
	*/
         if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_GetEntryByName Reply for Name: %s", key_t);
		}
 
	return offset;
}
static int 
vl_dissect_getsiteinfo_rqst (tvbuff_t *tvb, int offset,
		                 packet_info *pinfo, proto_tree *tree,
			         char *drep)
{
	guint16 type;
	guint8 data[14];
	extern guint32 master_seqnum;



		offset = dissect_ndr_uint16 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_type, &type);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data0, &data[0]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data1, &data[1]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data2, &data[2]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data3, &data[3]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data4, &data[4]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data5, &data[5]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data6, &data[6]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data7, &data[7]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data8, &data[8]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data9, &data[9]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data10, &data[10]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data11, &data[11]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data12, &data[12]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_rqst_data13, &data[13]);

      if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_GetSiteInfo Request type: %u, Data: %u%u%u%u%u%u%u%u%u%u%u%u%u%u", type, data[0], data[1], data[2], data[3], data[4], data[5], data[6], data[7], data[8], data[9], data[10], data[11], data[12], data[13]);

          if (check_col (pinfo->cinfo, COL_INFO)) {
		          col_append_fstr (pinfo->cinfo, COL_INFO, ": seq_num: %u", master_seqnum);
	   }

		/*
		 *
		 * [in] afsNetAddr *OldAddr,
		 *         unsigned16 type;
		           unsigned8 data[14];
		 */
		
								 
	return offset;
}
static int 
vl_dissect_getsiteinfo_resp (tvbuff_t *tvb, int offset,
		                 packet_info *pinfo, proto_tree *tree,
			         char *drep)
{
	guint16 type;
	guint8 data[14];
	char *key_t = NULL;
	guint32 key_size = 64;
	e_uuid_t owner, objid;
	guint32 creationquota, creationuses, deletedflag, spare2, spare3, spare4, spare5, error;

	extern guint32 master_seqnum;
	

	/*
		  [out] siteDesc *FullSiteInfo
                 	    afsNetAddr Addr[ADDRSINSITE];
        */

		offset = dissect_ndr_uint16 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_type, &type);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data0, &data[0]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data1, &data[1]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data2, &data[2]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data3, &data[3]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data4, &data[4]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data5, &data[5]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data6, &data[6]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data7, &data[7]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data8, &data[8]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data9, &data[9]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data10, &data[10]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data11, &data[11]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data12, &data[12]);
		offset = dissect_ndr_uint8 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_data13, &data[13]);
		/* what are we missing that needs this 48 byte bump? */
		offset += 48;

		/*

         		    byte KerbPrin[MAXKPRINCIPALLEN]; = 64
   	        */
                proto_tree_add_string (tree, hf_vl_getsiteinfo_resp_key_t, tvb, offset, hf_vl_getsiteinfo_resp_key_size, tvb_get_ptr (tvb, offset, key_size));
	        key_t = tvb_get_ptr(tvb,offset,key_size);
                offset += key_size; 

		/*
           		    afsUUID Owner;
       			    afsUUID ObjID;
    	     	            unsigned32 CreationQuota;
           		    unsigned32 CreationUses;
		            unsigned32 DeletedFlag;
		            unsigned32 spare2;
		            unsigned32 spare3;
		            unsigned32 spare4;
		            unsigned32 spare5;
  	        */
		offset = dissect_ndr_uuid_t (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_owner, &owner);
		offset = dissect_ndr_uuid_t (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_objid, &objid);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_creationquota, &creationquota);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_creationuses, &creationuses);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_deletedflag, &deletedflag);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_spare2, &spare2);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_spare3, &spare3);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_spare4, &spare4);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_spare5, &spare5);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getsiteinfo_resp_error, &error);
         if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_GetSiteInfo Reply KerbPrin: %s", key_t);
	     if (check_col (pinfo->cinfo, COL_INFO)) {
		             col_append_fstr (pinfo->cinfo, COL_INFO, ": seq_num: %u", master_seqnum);
	     }


}

static int 
vl_dissect_listentry_rqst (tvbuff_t *tvb, int offset,
		                 packet_info *pinfo, proto_tree *tree,
			         char *drep)
{
	        guint32 var1, previous_index;

		/*
		 *               [in] handle_t h,                   
		 *               [in] unsigned32 previous_index,
		 *               [out] unsigned32 *count,
	         *               [out] unsigned32 *next_index,
		 *               [out] vldbentry *entry
		 */
						 
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_listentry_rqst_previous_index, &previous_index);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_listentry_rqst_var1, &var1);


         if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_ListEntry Request PrevIndex: %u", previous_index);

		return offset;

}

static int 
vl_dissect_listentry_resp (tvbuff_t *tvb, int offset,
		                 packet_info *pinfo, proto_tree *tree,
			         char *drep)
{
		guint32  count, next_index, key_size, voltype, key_size2;
		char *key_t, *key_t2;
		key_size = 112;
		key_size2 = 64;

		/*
		 *               [out] unsigned32 *count,
	         *               [out] unsigned32 *next_index,
		 *               [out] vldbentry *entry
		 */
						 
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_listentry_resp_count, &count);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_listentry_resp_next_index, &next_index);
                proto_tree_add_string (tree, hf_vl_listentry_resp_key_t, tvb, offset, hf_vl_listentry_resp_key_size, tvb_get_ptr (tvb, offset, key_size));
	        key_t = tvb_get_ptr(tvb,offset,key_size);
                offset += key_size; 
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_listentry_resp_voltype, &voltype);
		offset += 452;
                proto_tree_add_string (tree, hf_vl_listentry_resp_key_t2, tvb, offset, hf_vl_listentry_resp_key_size2, tvb_get_ptr (tvb, offset, key_size2));
	        key_t2 = tvb_get_ptr(tvb,offset,key_size2);
                offset += key_size2; 

		if (*key_t2) {

         if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_ListEntry Response Vol: %s Count: %u NextIdx: %u", key_t, count, next_index);
		}else{
         if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_ListEntry Response Bad Enumeration on %s", key_t);
	 printf("Bad Enumeration on Fileset %s", key_t);

		}
		return offset;

}
static int 
vl_dissect_setlock_rqst (tvbuff_t *tvb, int offset,
				 packet_info *pinfo, proto_tree *tree,
				 char *drep)
{
		guint64 fsid;
		guint32 fsid_high, fsid_low, voltype, voloper;

		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_setlock_rqst_fsid_high, &fsid_high);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_setlock_rqst_fsid_low, &fsid_low);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_setlock_rqst_voltype, &voltype);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_setlock_rqst_voloper, &voloper);
		fsid = fsid_high | fsid_low;

	 if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_SetLock Request for FSID: %llu", fsid);

		return offset;

}
static int 
vl_dissect_deleteentry_rqst (tvbuff_t *tvb, int offset,
				 packet_info *pinfo, proto_tree *tree,
				 char *drep)
{
		guint64 fsid;
		guint32 fsid_high, fsid_low, voltype, voloper;

		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_deleteentry_rqst_fsid_high, &fsid_high);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_deleteentry_rqst_fsid_low, &fsid_low);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_deleteentry_rqst_voltype, &voltype);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_deleteentry_rqst_voloper, &voloper);
		fsid = fsid_high | fsid_low;

	 if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_DeleteEntry Request for FSID: %llu", fsid);

		return offset;

}
static int 
vl_dissect_createentry_rqst (tvbuff_t *tvb, int offset,
				 packet_info *pinfo, proto_tree *tree,
				 char *drep)
{
		guint32 key_size = 255;
		char *key_t;

                proto_tree_add_string (tree, hf_vl_createentry_rqst_key_t, tvb, offset, hf_vl_createentry_rqst_key_size, tvb_get_ptr (tvb, offset, key_size));
	        key_t = tvb_get_ptr(tvb,offset,key_size);
                offset += key_size; 


	 if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_CreateEntry Request for: %s", key_t);

		return offset;

}
static int 
vl_dissect_getentrybyid_rqst (tvbuff_t *tvb, int offset,
				 packet_info *pinfo, proto_tree *tree,
				 char *drep)
{
		guint64 fsid;
		guint32 fsid_high, fsid_low, voltype, voloper;

		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyid_rqst_fsid_high, &fsid_high);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyid_rqst_fsid_low, &fsid_low);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyid_rqst_voltype, &voltype);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_getentrybyid_rqst_voloper, &voloper);
		fsid = fsid_high | fsid_low;

	 if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_GetEntryByID Request for FSID: %llu", fsid);

		return offset;

}
static int
vl_dissect_releaselock_rqst (tvbuff_t *tvb, int offset,
				 packet_info *pinfo, proto_tree *tree,
				 char *drep)
{
		guint64 fsid;
		guint32 fsid_high, fsid_low, voltype, voloper;

		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_releaselock_rqst_fsid_high, &fsid_high);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_releaselock_rqst_fsid_low, &fsid_low);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_releaselock_rqst_voltype, &voltype);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_releaselock_rqst_voloper, &voloper);
		fsid = fsid_high | fsid_low;

	 if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_ReleaseLock Request for FSID: %llu", fsid);

		return offset;

}
static int
vl_dissect_replaceentry_rqst (tvbuff_t *tvb, int offset,
				 packet_info *pinfo, proto_tree *tree,
				 char *drep)
{
		guint64 fsid;
		guint32 fsid_high, fsid_low, voltype, voloper;
		guint32 key_size=100;
		char *key_t;
		/*
		 * [in] afsHyper *Volid,
		 * [in] unsigned32 voltype,
		 * [in] vldbentry *newentry,
		 * [in] unsigned32 ReleaseType
		 */

		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_replaceentry_rqst_fsid_high, &fsid_high);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_replaceentry_rqst_fsid_low, &fsid_low);
		offset = dissect_ndr_uint32 (tvb, offset, pinfo, tree, drep, hf_vl_replaceentry_rqst_voltype, &voltype);

                proto_tree_add_string (tree, hf_vl_replaceentry_rqst_key_t, tvb, offset, hf_vl_replaceentry_rqst_key_size, tvb_get_ptr (tvb, offset, key_size));
	        key_t = tvb_get_ptr(tvb,offset,key_size);
                offset += key_size; 
		fsid = fsid_high | fsid_low;

	 if (check_col(pinfo->cinfo, COL_INFO)) col_add_fstr(pinfo->cinfo, COL_INFO, "VL_ReplaceEntry Request for Name: %s FSID: %llu", key_t,fsid);

		return offset;

}
		 
		 
static dcerpc_sub_dissector VL__dissectors[] = {
	{ 0, "VL_GetEntryByID", vl_dissect_getentrybyid_rqst, NULL},
	{ 1, "VL_GetEntryByName", vl_dissect_getentrybyname_rqst, vl_dissect_getentrybyname_resp,},
	{ 2, "VL_Probe", NULL, NULL},
	{ 3, "VL_GetCellInfo", NULL, NULL},
	{ 4, "VL_GetNextServersByID", NULL, NULL},
	{ 5, "VL_GetNextServersByName", NULL, NULL},
	{ 6, "VL_GetSiteInfo", vl_dissect_getsiteinfo_rqst, vl_dissect_getsiteinfo_resp},
	{ 7, "VL_GetCEntryByID", NULL, NULL},
	{ 8, "VL_GetCEntryByName", NULL, NULL},
	{ 9, "VL_GetCNextServersByID", NULL, NULL},
	{ 10, "VL_GetCNextServersByName", NULL, NULL},
	{ 11, "VL_ExpandSiteCookie", NULL, NULL},
	{ 12, "VL_GetServerInterfaces", NULL, NULL},
	{ 13, "VL_CreateEntry", vl_dissect_createentry_rqst, NULL},
	{ 14, "VL_DeleteEntry", vl_dissect_deleteentry_rqst, NULL},
	{ 15, "VL_GetNewVolumeId", NULL, NULL},
	{ 16, "VL_ReplaceEntry", vl_dissect_replaceentry_rqst, NULL},
	{ 17, "VL_SetLock", vl_dissect_setlock_rqst, NULL},
	{ 18, "VL_ReleaseLock", vl_dissect_releaselock_rqst, NULL},
	{ 19, "VL_ListEntry", vl_dissect_listentry_rqst, vl_dissect_listentry_resp},
	{ 20, "VL_ListByAttributes", NULL, NULL},
	{ 21, "VL_GetStats", NULL, NULL},
	{ 22, "VL_AddAddress", NULL, NULL},
	{ 23, "VL_RemoveAddress", NULL, NULL},
	{ 24, "VL_ChangeAddress", NULL, NULL},
	{ 25, "VL_GenerateSites", NULL, NULL},
	{ 26, "VL_GetNewVolumeIds", NULL, NULL},
	{ 27, "VL_CreateServer", NULL, NULL},
	{ 28, "VL_AlterServer", NULL, NULL},
        { 0, NULL, NULL, NULL },
};


void
proto_register_VL_ (void)
{
	static hf_register_info hf[] = {
{ &hf_vl_getentrybyname_rqst_var1,
   {"Var1:", "hf_vl_getentrybyname_rqst_var1,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_rqst_key_size,
   {"Key_size:", "hf_vl_getentrybyname_rqst_key_size,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_rqst_key_t,
   {"Key:", "hf_vl_getentrybyname_rqst_key_t,", FT_STRING, BASE_NONE, NULL, 0x0, "", HFILL }},
{ &hf_vl_releaselock_rqst_fsid_high,
   {"FSID Hi:", "hf_vl_releaselock_rqst_fsid_high,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_releaselock_rqst_fsid_low,
   {"FSID Low:", "hf_vl_releaselock_rqst_fsid_low,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_releaselock_rqst_voltype,
   {"voltype:", "hf_vl_releaselock_rqst_voltype,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_releaselock_rqst_voloper,
   {"voloper:", "hf_vl_releaselock_rqst_voloper,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_setlock_rqst_fsid_high,
   {"FSID Hi:", "hf_vl_setlock_rqst_fsid_high,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_setlock_rqst_fsid_low,
   {"FSID Low:", "hf_vl_setlock_rqst_fsid_low,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_setlock_rqst_voltype,
   {"voltype:", "hf_vl_setlock_rqst_voltype,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_setlock_rqst_voloper,
   {"voloper:", "hf_vl_setlock_rqst_voloper,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_listentry_rqst_previous_index,
   {"Previous Index:", "hf_vl_listentry_rqst_previous_index,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_listentry_rqst_var1,
   {"Var 1:", "hf_vl_listentry_rqst_var1,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_listentry_resp_count,
   {"Count:", "hf_vl_listentry_resp_count,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_listentry_resp_next_index,
   {"Next Index:", "hf_vl_listentry_resp_next_index,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_listentry_resp_key_size,
   {"Key Size:", "hf_vl_listentry_resp_key_size,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_listentry_resp_key_t,
   {"Volume:", "hf_vl_listentry_resp_key_t,", FT_STRING, BASE_NONE, NULL, 0x0, "", HFILL }},
{ &hf_vl_listentry_resp_voltype,
   {"VolType:", "hf_vl_listentry_resp_voltype,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_listentry_resp_key_size2,
   {"key_size2:", "hf_vl_listentry_resp_key_size2,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_listentry_resp_key_t2,
   {"Server:", "hf_vl_listentry_resp_key_t2,", FT_STRING, BASE_NONE, NULL, 0x0, "", HFILL }},
{ &hf_vl_createentry_rqst_key_t,
   {"Volume:", "hf_vl_createentry_rqst_key_t,", FT_STRING, BASE_NONE, NULL, 0x0, "", HFILL }},
{ &hf_vl_createentry_rqst_key_size,
   {"Volume Size:", "hf_vl_createentry_rqst_key_size,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_deleteentry_rqst_fsid_high,
   {"FSID Hi:", "hf_vl_deleteentry_rqst_fsid_high,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_deleteentry_rqst_fsid_low,
   {"FSID Low:", "hf_vl_deleteentry_rqst_fsid_low,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_deleteentry_rqst_voltype,
   {"voltype:", "hf_vl_deleteentry_rqst_voltype,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_deleteentry_rqst_voloper,
   {"voloper:", "hf_vl_deleteentry_rqst_voloper,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyid_rqst_fsid_high,
   {"FSID Hi:", "hf_vl_getentrybyid_rqst_fsid_high,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyid_rqst_fsid_low,
   {"FSID Low:", "hf_vl_getentrybyid_rqst_fsid_low,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyid_rqst_voltype,
   {"voltype:", "hf_vl_getentrybyid_rqst_voltype,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyid_rqst_voloper,
   {"voloper:", "hf_vl_getentrybyid_rqst_voloper,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_replaceentry_rqst_fsid_high,
   {"FSID Hi:", "hf_vl_replaceentry_rqst_fsid_high,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_replaceentry_rqst_fsid_low,
   {"FSID Low:", "hf_vl_replaceentry_rqst_fsid_low,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_replaceentry_rqst_voltype,
   {"voltype:", "hf_vl_replaceentry_rqst_voltype,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_replaceentry_rqst_key_t,
   {"Key:", "hf_vl_replaceentry_rqst_key_t,", FT_STRING, BASE_NONE, NULL, 0x0, "", HFILL }},
{ &hf_vl_replaceentry_rqst_key_size,
   {"Key Size:", "hf_vl_replaceentry_rqst_key_size,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_volumetype,
   {"hf_vl_getentrybyname_resp_volumetype", "hf_vl_getentrybyname_resp_volumetype,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_numservers,
   {"hf_vl_getentrybyname_resp_numservers", "hf_vl_getentrybyname_resp_numservers,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_sitecookies,
   {"hf_vl_getentrybyname_resp_sitecookies", "hf_vl_getentrybyname_resp_sitecookies,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_sitepartition,
   {"hf_vl_getentrybyname_resp_sitepartition", "hf_vl_getentrybyname_resp_sitepartition,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_siteflags,
   {"hf_vl_getentrybyname_resp_siteflags", "hf_vl_getentrybyname_resp_siteflags,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_sitemaxreplat,
   {"hf_vl_getentrybyname_resp_sitemaxreplat", "hf_vl_getentrybyname_resp_sitemaxreplat,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_volid_high,
   {"hf_vl_getentrybyname_resp_volid_high", "hf_vl_getentrybyname_resp_volid_high,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_volid_low,
   {"hf_vl_getentrybyname_resp_volid_low", "hf_vl_getentrybyname_resp_volid_low,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_voltype,
   {"hf_vl_getentrybyname_resp_voltype", "hf_vl_getentrybyname_resp_voltype,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_cloneid_high,
   {"hf_vl_getentrybyname_resp_cloneid_high", "hf_vl_getentrybyname_resp_cloneid_high,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_cloneid_low,
   {"hf_vl_getentrybyname_resp_cloneid_low", "hf_vl_getentrybyname_resp_cloneid_low,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_flags,
   {"hf_vl_getentrybyname_resp_flags", "hf_vl_getentrybyname_resp_flags,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_maxtotallat,
   {"hf_vl_getentrybyname_resp_maxtotallat", "hf_vl_getentrybyname_resp_maxtotallat,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_hardmaxtotlat,
   {"hf_vl_getentrybyname_resp_hardmaxtotlat", "hf_vl_getentrybyname_resp_hardmaxtotlat,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_minpouncedally,
   {"hf_vl_getentrybyname_resp_minpouncedally", "hf_vl_getentrybyname_resp_minpouncedally,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_defaultmaxreplat,
   {"hf_vl_getentrybyname_resp_defaultmaxreplat", "hf_vl_getentrybyname_resp_defaultmaxreplat,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_reclaimdally,
   {"hf_vl_getentrybyname_resp_reclaimdally", "hf_vl_getentrybyname_resp_reclaimdally,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_whenlocked,
   {"hf_vl_getentrybyname_resp_whenlocked", "hf_vl_getentrybyname_resp_whenlocked,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_spare1,
   {"hf_vl_getentrybyname_resp_spare1", "hf_vl_getentrybyname_resp_spare1,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_spare2,
   {"hf_vl_getentrybyname_resp_spare2", "hf_vl_getentrybyname_resp_spare2,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_spare3,
   {"hf_vl_getentrybyname_resp_spare3", "hf_vl_getentrybyname_resp_spare3,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_spare4,
   {"hf_vl_getentrybyname_resp_spare4", "hf_vl_getentrybyname_resp_spare4,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_key_t,
   {"hf_vl_getentrybyname_resp_key_t", "hf_vl_getentrybyname_resp_key_t,", FT_STRING, BASE_NONE, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_key_size,
   {"hf_vl_getentrybyname_resp_size", "hf_vl_getentrybyname_resp_key_size,", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getentrybyname_resp_test,
   {"hf_vl_getentrybyname_resp_test", "hf_vl_getentrybyname_resp_test,", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_type,
       {"hf_vl_getsiteinfo_rqst_type", "hf_vl_getsiteinfo_rqst_type", FT_UINT16, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data0,
       {"hf_vl_getsiteinfo_rqst_data0", "hf_vl_getsiteinfo_rqst_data0", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data1,
       {"hf_vl_getsiteinfo_rqst_data1", "hf_vl_getsiteinfo_rqst_data1", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data2,
       {"hf_vl_getsiteinfo_rqst_data2", "hf_vl_getsiteinfo_rqst_data2", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data3,
       {"hf_vl_getsiteinfo_rqst_data3", "hf_vl_getsiteinfo_rqst_data3", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data4,
       {"hf_vl_getsiteinfo_rqst_data4", "hf_vl_getsiteinfo_rqst_data4", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data5,
       {"hf_vl_getsiteinfo_rqst_data5", "hf_vl_getsiteinfo_rqst_data5", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data6,
       {"hf_vl_getsiteinfo_rqst_data6", "hf_vl_getsiteinfo_rqst_data6", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data7,
       {"hf_vl_getsiteinfo_rqst_data7", "hf_vl_getsiteinfo_rqst_data7", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data8,
       {"hf_vl_getsiteinfo_rqst_data8", "hf_vl_getsiteinfo_rqst_data8", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data9,
       {"hf_vl_getsiteinfo_rqst_data9", "hf_vl_getsiteinfo_rqst_data9", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data10,
       {"hf_vl_getsiteinfo_rqst_data10", "hf_vl_getsiteinfo_rqst_data10", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data11,
       {"hf_vl_getsiteinfo_rqst_data11", "hf_vl_getsiteinfo_rqst_data11", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data12,
       {"hf_vl_getsiteinfo_rqst_data12", "hf_vl_getsiteinfo_rqst_data12", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_rqst_data13,
       {"hf_vl_getsiteinfo_rqst_data13", "hf_vl_getsiteinfo_rqst_data13", FT_UINT8, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_type,
{"hf_vl_getsiteinfo_resp_type", "hf_vl_getsiteinfo_resp_type", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data0,
{"hf_vl_getsiteinfo_resp_data0", "hf_vl_getsiteinfo_resp_data0", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data1,
{"hf_vl_getsiteinfo_resp_data1", "hf_vl_getsiteinfo_resp_data1", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data2,
{"hf_vl_getsiteinfo_resp_data2", "hf_vl_getsiteinfo_resp_data2", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data3,
{"hf_vl_getsiteinfo_resp_data3", "hf_vl_getsiteinfo_resp_data3", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data4,
{"hf_vl_getsiteinfo_resp_data4", "hf_vl_getsiteinfo_resp_data4", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data5,
{"hf_vl_getsiteinfo_resp_data5", "hf_vl_getsiteinfo_resp_data5", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data6,
{"hf_vl_getsiteinfo_resp_data6", "hf_vl_getsiteinfo_resp_data6", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data7,
{"hf_vl_getsiteinfo_resp_data7", "hf_vl_getsiteinfo_resp_data7", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data8,
{"hf_vl_getsiteinfo_resp_data8", "hf_vl_getsiteinfo_resp_data8", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data9,
{"hf_vl_getsiteinfo_resp_data9", "hf_vl_getsiteinfo_resp_data9", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data10,
{"hf_vl_getsiteinfo_resp_data10", "hf_vl_getsiteinfo_resp_data10", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data11,
{"hf_vl_getsiteinfo_resp_data11", "hf_vl_getsiteinfo_resp_data11", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data12,
{"hf_vl_getsiteinfo_resp_data12", "hf_vl_getsiteinfo_resp_data12", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_data13,
{"hf_vl_getsiteinfo_resp_data13", "hf_vl_getsiteinfo_resp_data13", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_key_t,
{"hf_vl_getsiteinfo_resp_key_t", "hf_vl_getsiteinfo_resp_key_t", FT_STRING, BASE_NONE, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_key_size,
{"hf_vl_getsiteinfo_resp_key_size", "hf_vl_getsiteinfo_resp_key_size", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_owner,
{"hf_vl_getsiteinfo_resp_owner", "hf_vl_getsiteinfo_resp_owner", FT_STRING, BASE_NONE, NULL, 0x0, "UUID", HFILL }},
{ &hf_vl_getsiteinfo_resp_objid,
{"hf_vl_getsiteinfo_resp_objid", "hf_vl_getsiteinfo_resp_objid", FT_STRING, BASE_NONE, NULL, 0x0, "UUID", HFILL }},
{ &hf_vl_getsiteinfo_resp_creationquota,
{"hf_vl_getsiteinfo_resp_creationquota", "hf_vl_getsiteinfo_resp_creationquota", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_creationuses,
{"hf_vl_getsiteinfo_resp_creationuses", "hf_vl_getsiteinfo_resp_creationuses", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_deletedflag,
{"hf_vl_getsiteinfo_resp_deletedflag", "hf_vl_getsiteinfo_resp_deletedflag", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_spare2,
{"hf_vl_getsiteinfo_resp_spare2", "hf_vl_getsiteinfo_resp_spare2", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_spare3,
{"hf_vl_getsiteinfo_resp_spare3", "hf_vl_getsiteinfo_resp_spare3", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_spare4,
{"hf_vl_getsiteinfo_resp_spare4", "hf_vl_getsiteinfo_resp_spare4", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_spare5,
{"hf_vl_getsiteinfo_resp_spare5", "hf_vl_getsiteinfo_resp_spare5", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
{ &hf_vl_getsiteinfo_resp_error,
{"hf_vl_getsiteinfo_resp_error", "hf_vl_getsiteinfo_resp_error", FT_UINT32, BASE_DEC, NULL, 0x0, "", HFILL }},
	};

	static gint *ett[] = {
		&ett_VL_,
	};
	proto_VL_ = proto_register_protocol ("DCE/RPC FLDB", "FLDB", "FLDB");
	proto_register_field_array (proto_VL_, hf, array_length (hf));
	proto_register_subtree_array (ett, array_length (ett));
}

void
proto_reg_handoff_VL_ (void)
{
	/* Register the protocol as dcerpc */
	dcerpc_init_uuid (proto_VL_, ett_VL_, &uuid_VL_, ver_VL_, VL__dissectors, -1);
}
